// Codigo para generar a partir de los nodos que se encuentren en stator.reg
// valores de densidad de corriente para un estator trifásico.
// Cuidado, se sobre-escribe el archivo densidadCorri.reg con las regiones conductoras
// de estator, pero el resto de regiones conductoras tendrán que escribirse a mano.
//
// Este codigo tambien puede ser utilizado para generar una secuencia de posiciones del
// campo magnético giratorio de un estator. Tal parte de codigo permanece comentado.

#include <iostream>
#include <string>
#include <math.h>
#include <fstream>
#include <stdlib.h>
#define PI 3.14159265358979323846264338327950288419716939937510
using namespace std;

int densidadGiro( double, double, int, int );

int main()
{
	double angInicial, maximo=8000000;
	char renombrar[40];
	int numEspiras=36;
	int numParPolos=2;
	int EPPP=numEspiras/numParPolos; // EPPP espiras por par de polos
	int espirasPorGrupo=EPPP/6;

	for(int i=0; i<1; i++){ // bucle en caso de que se necesiten hacer calculos en varias posiciones del campo magnetico
		angInicial=i*PI/32;
		densidadGiro(angInicial, maximo, EPPP, espirasPorGrupo);
/*		system("cli.bin .");
		system("gmsh captura.script");
		sprintf( renombrar, "mv render.jpg zrender%d.jpg", i+1001);
		cout << renombrar << endl;
		system(renombrar);*/
	}

//	system("mencoder 'mf://zrender*.jpg' -mf fps=50 -o animation.avi -ovc x264 -x264encopts bitrate=20000:threads=3");
}

int densidadGiro( double angInicial, double maximo, int numEspiras, int EPG )
{
	ifstream fileDensidad;
	ofstream fileSalida;
	int N_C, *nodo, j=0;
	double angulo, real, imag;

	// funciona con mas espiras por fase; o con mas fases ?
	
	angulo=PI*2/(numEspiras/EPG); // variacion del angulo por cada fase *1/2


	fileDensidad.open("stator.reg", ios::in);
		if(!fileDensidad.is_open())
			{cout<<"Densico: Error leyendo archivo 0.densidadCorri.reg\n";exit(0);}
	fileDensidad >> N_C;
	nodo = new int[N_C];

	for(int i=0; i<N_C; i++){
		fileDensidad >> nodo[i];
	}
	fileDensidad.close();


	fileSalida.precision( 16 ); // set precision to output fileNode
	fileSalida.open("densidadCorri.reg", ios::out);
		if(!fileSalida.is_open())
			{cout<<"Densico: Error creando archivo densidadCorri.reg\n";exit(0);}
	fileSalida << N_C << endl;
	while(j<N_C){
		for( int i=0;i<EPG; i++){
			real = maximo*(sin(((j/EPG)*angulo)+angInicial));
			imag = maximo*(cos(((j/EPG)*angulo)+angInicial));
			fileSalida <<nodo[i+j]<<' '<< real <<' '<<imag<<endl;
		}
		j=j+EPG;
	}

	fileSalida << 'F';
	fileSalida.close();
	return 1;
}
