
/* Variables that must be defined when including this file:
   th,D1,H,R1,R2,Lc */

dth = Pi - ArcCos((R1 - R2) / (H - R1 - R2)) ;

th0 = th - dth/12 ;
th1 = th + dth/12 ;

R1m = R1/2; // circle leng
pcero = newp ; Point(pcero) = {0, 0, 0};
// th0

XT1 = (D1 + R1m/2) * Cos(th - dth/10) ;		// tentacle top
YT1 = (D1 + R1m/2) * Sin(th - dth/10) ;
pSup0 = newp ; Point(pSup0) = { XT1 , YT1, 0., Lc} ;
XT1 = (D1 - 1.5*R1m) * Cos(th - dth/10) ;		// tentacle semi-top
YT1 = (D1 - 1.5*R1m) * Sin(th - dth/10) ;
pInf0 = newp ; Point(pInf0) = { XT1 , YT1, 0., Lc} ;

XC1 = (D1 - 3*R1m) * Cos(th0) ;		// circle01 center
YC1 = (D1 - 3*R1m) * Sin(th0) ;
XS1 = (D1 - 2*R1m) * Cos(th0) ;		// circle01 top
YS1 = (D1 - 2*R1m) * Sin(th0) ;
XI1 = (D1 - 4*R1m) * Cos(th0) ;		// circle01 botton
YI1 = (D1 - 4*R1m) * Sin(th0) ;
XA1 = XC1 + R1m * Cos(th0 - dth) ;	// right01 point
YA1 = YC1 + R1m * Sin(th0 - dth) ;
XB1 = XC1 + R1m * Cos(th0 + dth) ; 	// left01 point
YB1 = YC1 + R1m * Sin(th0 + dth) ;

// Pole

/* 'newp' is a meta variable defining a new point number for
   you.  This is mostly useful with included files. There is also
   'newreg' which defines a new region number (that is, everything
   that is not a point). */

p1 = newp ; Point(p1) = { XC1 , YC1, 0., Lc} ; // circle center
p2 = newp ; Point(p2) = { XI1 , YI1, 0., Lc} ; // circle botton
p3 = newp ; Point(p3) = { XA1 , YA1, 0., Lc} ; // right point
p4 = newp ; Point(p4) = { XS1 , YS1, 0., Lc} ; // circle top
p5 = newp ; Point(p5) = { XB1 , YB1, 0., Lc} ; // left point

arc1 = newreg ; Circle (arc1) = {p2,p1,p3} ;
arc2 = newreg ; Circle (arc2) = {p3,p1,p4} ;
arc3 = newreg ; Circle (arc3) = {p4,p1,p5} ;
arc4 = newreg ; Circle (arc4) = {p5,p1,p2} ;

reg1 = newreg ; Line Loop(reg1) = {arc1,arc2,arc3,arc4};
reg2 = newreg ; Plane Surface(reg2) = {reg1};

// second circles
XC1 = (D1 - 5*R1m) * Cos(th0) ;		// circle01 center
YC1 = (D1 - 5*R1m) * Sin(th0) ;
XS1 = (D1 - 4*R1m) * Cos(th0) ;		// circle01 top
YS1 = (D1 - 4*R1m) * Sin(th0) ;
XI1 = (D1 - 6*R1m) * Cos(th0) ;		// circle01 botton
YI1 = (D1 - 6*R1m) * Sin(th0) ;
XA1 = XC1 + R1m * Cos(th0 - dth) ;	// right01 point
YA1 = YC1 + R1m * Sin(th0 - dth) ;
XB1 = XC1 + R1m * Cos(th0 + dth) ; 	// left01 point
YB1 = YC1 + R1m * Sin(th0 + dth) ;
p6 = newp ; Point(p6) = { XC1 , YC1, 0., Lc} ; // circle center
p7 = newp ; Point(p7) = { XI1 , YI1, 0., Lc} ; // circle botton
p8 = newp ; Point(p8) = { XA1 , YA1, 0., Lc} ; // right point
// p9 = newp ; Point(p9) = { XS1 , YS1, 0., Lc} ; // circle top
p10 = newp ; Point(p10) = { XB1 , YB1, 0., Lc} ; // left point
arc5 = newreg ; Circle (arc5) = {p7,p6,p8} ;
arc6 = newreg ; Circle (arc6) = {p8,p6,p2} ;
arc7 = newreg ; Circle (arc7) = {p2,p6,p10} ;
arc8 = newreg ; Circle (arc8) = {p10,p6,p7} ;
reg3 = newreg ; Line Loop(reg3) = {arc5,arc6,arc7,arc8};
reg4 = newreg ; Plane Surface(reg4) = {reg3};

// third circles
XC1 = (D1 - 7*R1m) * Cos(th0) ;		// circle01 center
YC1 = (D1 - 7*R1m) * Sin(th0) ;
XS1 = (D1 - 6*R1m) * Cos(th0) ;		// circle01 top
YS1 = (D1 - 6*R1m) * Sin(th0) ;
XI1 = (D1 - 8*R1m) * Cos(th0) ;		// circle01 botton
YI1 = (D1 - 8*R1m) * Sin(th0) ;
XA1 = XC1 + R1m * Cos(th0 - dth) ;	// right01 point
YA1 = YC1 + R1m * Sin(th0 - dth) ;
XB1 = XC1 + R1m * Cos(th0 + dth) ; 	// left01 point
YB1 = YC1 + R1m * Sin(th0 + dth) ;
p11 = newp ; Point(p11) = { XC1 , YC1, 0., Lc} ; // circle center
p12 = newp ; Point(p12) = { XI1 , YI1, 0., 2*Lc} ; // circle botton
p13 = newp ; Point(p13) = { XA1 , YA1, 0., Lc} ; // right point
// p14 = newp ; Point(p14) = { XS1 , YS1, 0., Lc} ; // circle top
p15 = newp ; Point(p15) = { XB1 , YB1, 0., Lc} ; // left point
arc9 = newreg ; Circle (arc9) = {p12,p11,p13} ;
arc10 = newreg ; Circle (arc10) = {p13,p11,p7} ;
arc11 = newreg ; Circle (arc11) = {p7,p11,p15} ;
arc12 = newreg ; Circle (arc12) = {p15,p11,p12} ;
reg5 = newreg ; Line Loop(reg5) = {arc9,arc10,arc11,arc12};
reg6 = newreg ; Plane Surface(reg6) = {reg5};


// th1

XT1 = (D1 + R1m/2) * Cos(th + dth/10) ;		// tentacle top
YT1 = (D1 + R1m/2) * Sin(th + dth/10) ;
pSup1 = newp ; Point(pSup1) = { XT1 , YT1, 0., Lc} ;
XT1 = (D1 - 1.5*R1m) * Cos(th + dth/10) ;		// tentacle semi-top
YT1 = (D1 - 1.5*R1m) * Sin(th + dth/10) ;
pInf1 = newp ; Point(pInf1) = { XT1 , YT1, 0., Lc} ;

XC1 = (D1 - 3*R1m) * Cos(th1) ;             // circle center
YC1 = (D1 - 3*R1m) * Sin(th1) ;
XS1 = (D1 - 2*R1m) * Cos(th1) ;		        // circle top
YS1 = (D1 - 2*R1m) * Sin(th1) ;
XI1 = (D1 - 4*R1m) * Cos(th1) ;             // circle botton
YI1 = (D1 - 4*R1m) * Sin(th1) ;

XA1 = XC1 + R1m * Cos(th1 - dth) ;	// right point
YA1 = YC1 + R1m * Sin(th1 - dth) ;
XB1 = XC1 + R1m * Cos(th1 + dth) ; 	// left point
YB1 = YC1 + R1m * Sin(th1 + dth) ;

// Pole

/* 'newp' is a meta variable defining a new point number for
   you.  This is mostly useful with included files. There is also
   'newreg' which defines a new region number (that is, everything
   that is not a point). */

p101 = newp ; Point(p101) = { XC1 , YC1, 0., Lc} ; // circle center
p102 = newp ; Point(p102) = { XI1 , YI1, 0., Lc} ; // circle botton
p103 = newp ; Point(p103) = { XA1 , YA1, 0., Lc} ; // right point
p104 = newp ; Point(p104) = { XS1 , YS1, 0., Lc} ; // circle top
p105 = newp ; Point(p105) = { XB1 , YB1, 0., Lc} ; // left point

arc101 = newreg ; Circle (arc101) = {p102,p101,p103} ;
arc102 = newreg ; Circle (arc102) = {p103,p101,p104} ;
arc103 = newreg ; Circle (arc103) = {p104,p101,p105} ;
arc104 = newreg ; Circle (arc104) = {p105,p101,p102} ;

reg101 = newreg ; Line Loop(reg101) = {arc101,arc102,arc103,arc104};
reg102 = newreg ; Plane Surface(reg102) = {reg101};

// second circles
XC1 = (D1 - 5*R1m) * Cos(th1) ;		// circle01 center
YC1 = (D1 - 5*R1m) * Sin(th1) ;
XS1 = (D1 - 4*R1m) * Cos(th1) ;		// circle01 top
YS1 = (D1 - 4*R1m) * Sin(th1) ;
XI1 = (D1 - 6*R1m) * Cos(th1) ;		// circle01 botton
YI1 = (D1 - 6*R1m) * Sin(th1) ;
XA1 = XC1 + R1m * Cos(th1 - dth) ;	// right01 point
YA1 = YC1 + R1m * Sin(th1 - dth) ;
XB1 = XC1 + R1m * Cos(th1 + dth) ; 	// left01 point
YB1 = YC1 + R1m * Sin(th1 + dth) ;
p106 = newp ; Point(p106) = { XC1 , YC1, 0., Lc} ; // circle center
p107 = newp ; Point(p107) = { XI1 , YI1, 0., Lc} ; // circle botton
p108 = newp ; Point(p108) = { XA1 , YA1, 0., Lc} ; // right point
// p109 = newp ; Point(p109) = { XS1 , YS1, 0., Lc} ; // circle top
p110 = newp ; Point(p110) = { XB1 , YB1, 0., Lc} ; // left point
arc105 = newreg ; Circle (arc105) = {p107,p106,p108} ;
arc106 = newreg ; Circle (arc106) = {p108,p106,p102} ;
arc107 = newreg ; Circle (arc107) = {p102,p106,p110} ;
arc108 = newreg ; Circle (arc108) = {p110,p106,p107} ;
reg103 = newreg ; Line Loop(reg103) = {arc105,arc106,arc107,arc108};
reg104 = newreg ; Plane Surface(reg104) = {reg103};


// third circles
XC1 = (D1 - 7*R1m) * Cos(th1) ;		// circle01 center
YC1 = (D1 - 7*R1m) * Sin(th1) ;
XS1 = (D1 - 6*R1m) * Cos(th1) ;		// circle01 top
YS1 = (D1 - 6*R1m) * Sin(th1) ;
XI1 = (D1 - 8*R1m) * Cos(th1) ;		// circle01 botton
YI1 = (D1 - 8*R1m) * Sin(th1) ;
XA1 = XC1 + R1m * Cos(th1 - dth) ;	// right01 point
YA1 = YC1 + R1m * Sin(th1 - dth) ;
XB1 = XC1 + R1m * Cos(th1 + dth) ; 	// left01 point
YB1 = YC1 + R1m * Sin(th1 + dth) ;
p111 = newp ; Point(p111) = { XC1 , YC1, 0., Lc} ; // circle center
p112 = newp ; Point(p112) = { XI1 , YI1, 0., 2*Lc} ; // circle botton
p113 = newp ; Point(p113) = { XA1 , YA1, 0., Lc} ; // right point
// p114 = newp ; Point(p114) = { XS1 , YS1, 0., Lc} ; // circle top
p115 = newp ; Point(p115) = { XB1 , YB1, 0., Lc} ; // left point
arc109 = newreg ; Circle (arc109) = {p112,p111,p113} ;
arc110 = newreg ; Circle (arc110) = {p113,p111,p107} ;
arc111 = newreg ; Circle (arc111) = {p107,p111,p115} ;
arc112 = newreg ; Circle (arc112) = {p115,p111,p112} ;
reg105 = newreg ; Line Loop(reg105) = {arc109,arc110,arc111,arc112};
reg106 = newreg ; Plane Surface(reg106) = {reg105};

// Drawing the rest
lin1 = newreg ; Line(lin1) = {p4, pInf0} ;
lin2 = newreg ; Line(lin2) = {pInf0, pSup0} ;
lin3 = newreg ; Line(lin3) = {p104, pInf1} ;
lin4 = newreg ; Line(lin4) = {pInf1, pSup1} ;
arc120 = newreg ; Circle (arc120) = {pSup0 ,pcero, pSup1} ;